//+------------------------------------------------------------------+
//|                                                  WeeklyPivot.mq4 |
//|  I found the original indicator in TSD forum posted by heliyaun. |
//|                                       I dont know how wrote it. |
//| I like it because have mondays fixed for broker with GMT outside |
//| london time.                                                     |
//| So, I added some stuff, labels, fix, etc. and them, I wrote the|
//|             Medians SR, and then, I wrote the same for Monthlies |
//|                                                                  |
//|                                                           Enjoy. |
//|                                                                  |
//|                                           Linuxser, January 2007 |
//|                                                                  |
//+------------------------------------------------------------------+

#property indicator_chart_window
#property indicator_buffers 7
#property indicator_color1 LightSkyBlue
#property indicator_color2 RoyalBlue
#property indicator_color3 Teal
#property indicator_color4 CornflowerBlue
#property indicator_color5 SeaGreen
#property indicator_color6 LightSkyBlue

//---- input parameters

extern color     LabelColor=SeaGreen;
extern int       fontsize=9;
extern int       LabelShift = 0;

//---- buffers
double WM0Buffer[];
double WM1Buffer[];
double WM2Buffer[];
double WM3Buffer[];
double WM4Buffer[];
double WM5Buffer[];
string Pivot="WeeklyPivotPoint",Sup1="WM0", Res1="WM1";
string Sup2="WM2", Res2="WM3", Sup3="WM4", Res3="WM5";
double WMP,WM0,WM1,WM2,WM3,WM4,WM5,WM6,WM7;
double last_week_high, last_week_low, this_week_open, last_week_close;
datetime LabelShiftTime;
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- TODO: add your code here

   ObjectDelete("WM0");
   ObjectDelete("WM1");
   ObjectDelete("WM2");
   ObjectDelete("WM3");
   ObjectDelete("WM4");
   ObjectDelete("WM5");
   ObjectDelete("WM6");   

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   string short_name;


//---- indicator line
   SetIndexStyle(0,DRAW_LINE,EMPTY);
   SetIndexStyle(1,DRAW_LINE,EMPTY);
   SetIndexStyle(2,DRAW_LINE,EMPTY);
   SetIndexStyle(3,DRAW_LINE,EMPTY);
   SetIndexStyle(4,DRAW_LINE,EMPTY);
   SetIndexStyle(5,DRAW_LINE,EMPTY);
   SetIndexStyle(6,DRAW_LINE,EMPTY);
   SetIndexBuffer(0,WM0Buffer);
   SetIndexBuffer(1,WM1Buffer);
   SetIndexBuffer(2,WM2Buffer);
   SetIndexBuffer(3,WM3Buffer);
   SetIndexBuffer(4,WM4Buffer);
   SetIndexBuffer(5,WM5Buffer);


//---- name for DataWindow and indicator subwindow label
   short_name="Pivot Point Medians Weekly";
   IndicatorShortName(short_name);
   SetIndexLabel(0,short_name);

//----
   SetIndexDrawBegin(0,1);
//----
 

//----
   return(0);
  }

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()

  {
   int counted_bars=IndicatorCounted();

   int limit, i;
//---- indicator calculation
if (counted_bars==0)
{
   if(Period() > 1440)
   {
   Print("Error - Chart period is greater than 1 day.");
   return(-1); // then exit
   }
   
}
   if(counted_bars<0) return(-1);

   limit=(Bars-counted_bars)-1;


for (i=limit; i>=0;i--)
{ 


   // Monday
	if ( 1 == TimeDayOfWeek(Time[i]) && 1 != TimeDayOfWeek(Time[i+1]) )
	{
		last_week_close = Close[i+1];
		this_week_open = Open[i];

		// WeeklyPivot
	WMP = (last_week_high + last_week_low + last_week_close) / 3;

   WM0 = (3*last_week_low-2*last_week_high+last_week_close)/2;
   WM1 = (2*last_week_low-last_week_high+last_week_close)/2;
   WM2 = (last_week_low+last_week_close)/2;
   WM3 = (last_week_high+last_week_close)/2;
   WM4 = (2*last_week_high-last_week_low+last_week_close)/2;
   WM5 = (3*last_week_high-2*last_week_low+last_week_close)/2;  

  
   last_week_low=Low[i]; last_week_high=High[i];

   LabelShiftTime = Time[LabelShift];

      ObjectCreate("WM0", OBJ_TEXT, 0, LabelShiftTime, 0);
      ObjectSetText("WM0", "                      W M0 " +DoubleToStr(WM0,4),fontsize,"tahoma ",LabelColor);
      SetIndexLabel(0, "WM0");
      ObjectCreate("WM1", OBJ_TEXT, 0, LabelShiftTime, 0);
      ObjectSetText("WM1", "                      W M1 " +DoubleToStr(WM1,4),fontsize,"tahoma ",LabelColor);
      SetIndexLabel(1, "WM1");
      ObjectCreate("WM2", OBJ_TEXT, 0, LabelShiftTime, 0);
      ObjectSetText("WM2", "                      W M2 " +DoubleToStr(WM2,4),fontsize,"tahoma ",LabelColor);
      SetIndexLabel(2, "WM2");
      ObjectCreate("WM3", OBJ_TEXT, 0, LabelShiftTime, 0);
      ObjectSetText("WM3", "                      W M3 " +DoubleToStr(WM3,4),fontsize,"tahoma ",LabelColor);
      SetIndexLabel(3, "WM3");
      ObjectCreate("WM4", OBJ_TEXT, 0, LabelShiftTime, 0);
      ObjectSetText("WM4", "                      W M4 " +DoubleToStr(WM4,4),fontsize,"tahoma ",LabelColor);
      SetIndexLabel(4, "WM4");
      ObjectCreate("WM5", OBJ_TEXT, 0, LabelShiftTime, 0);
      ObjectSetText("WM5", "                      W M5 " +DoubleToStr(WM5,4),fontsize,"tahoma ",LabelColor);
      SetIndexLabel(5, "WM5");
      Print("ObjectSet Done");
      ObjectMove("WM0", 0, LabelShiftTime,WM0);
      ObjectMove("WM1", 0, LabelShiftTime,WM1);
      ObjectMove("WM2", 0, LabelShiftTime,WM2);
      ObjectMove("WM3", 0, LabelShiftTime,WM3);
      ObjectMove("WM4", 0, LabelShiftTime,WM4);
      ObjectMove("WM5", 0, LabelShiftTime,WM5);

}   
    
    last_week_high = MathMax(last_week_high, High[i]);
 	 last_week_low = MathMin(last_week_low, Low[i]);   
    
    WM0Buffer[i]=WM0;
    WM1Buffer[i]=WM1;
    WM2Buffer[i]=WM2;
    WM3Buffer[i]=WM3;
    WM4Buffer[i]=WM4;
    WM5Buffer[i]=WM5;

}

//----
   return(0);
  }
//+------------------------------------------------------------------+